<?php

/**
 * name		init.php
 * begin	April 23, 2007
 * 
 * $Id: init.php 62 2009-12-21 16:45:12Z trellmor $
 */

/**
 * yabs - yet another blog system
 * Copyright (C) 2007 Daniel Triendl
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301, USA
 *
 * http://www.gnu.org/copyleft/gpl.html
 */

if ( !defined('INSIDE') ) die( 'Don\'t call this file directly.' );

error_reporting( E_ALL );
$rendertime_start = array_sum(explode(" ", microtime()));

$yabs_version = '0.8.1';

if( file_exists( './install' ) ) {
	die('Please delete, move or rename the install directory if you already installed or updated yabs or go to <a href="http://' . $_SERVER['HTTP_HOST'] . dirname( $_SERVER['PHP_SELF'] ) . '/install/install.php">install/install.php</a> to do so.');
}

// Load basic stuff	
$config = array();
/*
 * Undocumentated config keys
 *  - session		Set this to default to enable default php session handling
 *					(uses custom session inside a database otherwise)
 *  - sid			Set this to false, to surpress output of sid url parameter
 * 					if no cookie for the session id exists
 *  - use_socket	Set to true, to disable curl for url fetching.
 *  - debug			Debug mode for some stuff
 */
require_once( './includes/config.php' );
if (isset($config['debug']) && $config['debug'] == true) {
	error_reporting(E_ALL);
} else {
	error_reporting(E_ALL);
}

require_once( './includes/sites.php' );
require_once( './includes/tables.php' );

require_once( './includes/autoload.php' ); 
require_once( './includes/functions.php' );

if( file_exists( './includes/preload.php' ) && ( empty( $config['noplugins'] ) || !$config['noplugins'] ) ) {
	include_once( './includes/preload.php' );
}

//Start a connection to the mysql server
$db = new $dbtype($dbhost, $dbuser, $dbpass, $dbname);
unset($dbpass);	

// Load the Config from the Server
$sql = "SELECT
			config_name,
			config_value
		FROM
			" . TABLE_CONFIG . ";";
$res = $db->query( $sql, __LINE__, __FILE__ );
while ( $row = $db->fetch( $res ) ) {
	$config[$row['config_name']] = $row['config_value'];
}

if(!(isset($config['debug']) && $config['debug'] == true) && version_compare($config['version'], $yabs_version) == -1) die('Database version is lower then file version, run <a href="http://' . $_SERVER['HTTP_HOST'] . dirname( $_SERVER['PHP_SELF'] ) . '/install/install.php">install/install.php</a> to update the database.');

if( $config['mod_rewrite'] == '1' && basename( $_SERVER['PHP_SELF'] ) != 'admin.php' ) {
	make_get();
}

//Ok, now we know the language, so load the language file
require_once('./languages/'.$config['language'].'.php');

// Load dummy session for plugins that require sessions
if( !isset( $config['session_default'] ) ) $config['session_default'] = false;
$session = session::singleton( $config['session_default'] );

$plug = plugin::singleton();
include_once( './includes/plugins.php' );

eval( $plug->registerPlugins() );

$plug->runhook( 'hook_init_done' );

?>
